#!/usr/bin/env python3

from dicevm import *

import numpy as np


elf = open("lost_in_your_eyes", "rb").read()
vm_input = elf[0x30A0: 0x30A0+4900]

# This is what main() does.
# That data only initializes the first 70 bytes of every 256-byte bank.
# It probably means that each bank is 70 bytes of code and 256-70 bytes of 0-initialized data.
vm_memory = [0x00] * 65536
for i in range(len(vm_input)):
 vm_memory[256 * (i // 70) + (i % 70)] = vm_input[i]

# Show a colorful map of __everything__ in the playfield
render_field(vm_memory)




# This is useful for 2D slicing
maze = []
for row in range(70):
  r = []
  for col in range(70):
    op = vm_input[(70 * col) + row]
    r.append(op)
  maze.append(r)

maze = np.array(maze)

# Slice out some bytes and print pseudo-assembly
disasm(maze[21:52,2])
